IF EXISTS (SELECT * FROM dbo.SysObjects WHERE id = object_id(N'dbo.AUDIT_upd_WareGroupsDepartmentsXtab') AND OBJECTPROPERTY(id, N'IsTrigger') = 1) DROP TRIGGER dbo.AUDIT_upd_WareGroupsDepartmentsXtab 
GO
CREATE TRIGGER [dbo].[AUDIT_upd_WareGroupsDepartmentsXtab]
ON [dbo].[WareGroupsDepartmentsXtab] FOR UPDATE NOT FOR REPLICATION AS
BEGIN
	  
	DECLARE @FiscalSweden INT
	SELECT @FiscalSweden = COUNT(*) 
	FROM dbo.HotelSetup h WITH (NOLOCK) 
	INNER JOIN HotelSetupValueXTab vx WITH (NOLOCK) ON vx.HotelSetupNumber = h.HotelSetupNumber AND UPPER(h.SearchKey) = UPPER('FiscalPrinterSweden')
	INNER JOIN HotelSetupValue v WITH (NOLOCK) ON vx.fk_ValueNumber = v.Pk_ValueNumber
	WHERE v.KeyValue = '1'
	IF ISNULL(@FiscalSweden, 0) = 0
		RETURN
	

	DECLARE 
		@IDENTITY_SAVE			varchar(50),
		@AUDIT_LOG_TRANSACTION_ID	Int,
		@PRIM_KEY			nvarchar(4000),
		@Inserted	    		bit,
 		@ROWS_COUNT				int,
		@FK_UserIdNumber INT,
		@FK_CashBox INT,
		@ProgramPart SMALLINT,
		@TerminalName VARCHAR(50),
		@SystemDateStr VARCHAR(8),
		@SystemDateTime DATETIME
 
	SET NOCOUNT ON

	Select @ROWS_COUNT=count(*) from inserted
	SET @IDENTITY_SAVE = CAST(IsNull(@@IDENTITY,1) AS varchar(50))

    SELECT TOP 1 @FK_UserIdNumber = FK_UserIdNumber,
	@FK_CashBox = FK_CashBox,
	@ProgramPart = ProgramPart,
	@TerminalName = TerminalName
	FROM PersonnelLogInfo WITH (NOLOCK)
	WHERE spid = @@spid 
	ORDER BY CreateDate DESC

	IF ISNULL(@FK_UserIdNumber, 0) = 0
	  SET @FK_UserIdNumber = 1
	IF ISNULL(@FK_CashBox, -1) <= 0
	  SET @FK_CashBox = -1
	IF ISNULL(@ProgramPart, -1) <= 0
	  SET @ProgramPart = 14 -- ppUnknown from SystemAll
	IF ISNULL(@TerminalName, '') = ''
	  SET @TerminalName = 'Unknown'

    SELECT @SystemDateStr = SystemDate FROM System WITH (NOLOCK) WHERE Number = 1
    SET @SystemDateTime = CONVERT(DATETIME, @SystemDateStr + ' ' + CONVERT(CHAR(8), CURRENT_TIMESTAMP, 108))

	INSERT INTO dbo.AUDIT_LOG_TRANSACTIONS 
	(
		TABLE_NAME,
		TABLE_SCHEMA,
		AUDIT_ACTION_ID,
		HOST_NAME,
		APP_NAME,
		MODIFIED_BY,
		MODIFIED_DATE,
		AFFECTED_ROWS,
		FK_UserIdNumber,
		FK_CashBox,
		ProgramPart,
		TerminalName,
		RealDateTime
	)
	values(
		'WareGroupsDepartmentsXtab',
		'dbo',
		1,	--	ACTION ID For UPDATE
		CASE 
		  WHEN LEN(HOST_NAME()) < 1 THEN ' '
		  ELSE HOST_NAME()
		END,
		CASE 
		  WHEN LEN(APP_NAME()) < 1 THEN ' '
		  ELSE APP_NAME()
		END,
		SUSER_SNAME(),
		@SystemDateTime,
		@ROWS_COUNT,
		@FK_UserIdNumber,
		@FK_CashBox,
		@ProgramPart,
		@TerminalName,
		GETDATE()
	)	
	
	Set @AUDIT_LOG_TRANSACTION_ID = SCOPE_IDENTITY()
		
	SET @Inserted = 0
	
	If UPDATE([SortNumber])
	BEGIN
    
		INSERT
		INTO dbo.AUDIT_LOG_DATA 
		(
			AUDIT_LOG_TRANSACTION_ID,
			PRIMARY_KEY_DATA,
			COL_NAME,
			OLD_VALUE_LONG,
			NEW_VALUE_LONG,
			DATA_TYPE
			, KEY1, KEY2, KEY3
		)
		SELECT
			@AUDIT_LOG_TRANSACTION_ID,
		    convert(nvarchar(1500), IsNull('[WareGroupNumber]='+CONVERT(nvarchar(4000), IsNull(OLD.[WareGroupNumber], NEW.[WareGroupNumber]), 0), '[WareGroupNumber] Is Null')+' AND '+IsNull('[FK_Department]='+CONVERT(nvarchar(4000), IsNull(OLD.[FK_Department], NEW.[FK_Department]), 0), '[FK_Department] Is Null')+' AND '+IsNull('[Type]='+CONVERT(nvarchar(4000), IsNull(OLD.[Type], NEW.[Type]), 0), '[Type] Is Null')),
		    'SortNumber',
			CONVERT(nvarchar(4000), OLD.[SortNumber], 0),
			CONVERT(nvarchar(4000), NEW.[SortNumber], 0),
			'A'
			, IsNULL( CONVERT(nvarchar(500), CONVERT(nvarchar(4000), OLD.[WareGroupNumber], 0)), CONVERT(nvarchar(500), CONVERT(nvarchar(4000), NEW.[WareGroupNumber], 0))), IsNULL( CONVERT(nvarchar(500), CONVERT(nvarchar(4000), OLD.[FK_Department], 0)), CONVERT(nvarchar(500), CONVERT(nvarchar(4000), NEW.[FK_Department], 0))), IsNULL( CONVERT(nvarchar(500), CONVERT(nvarchar(4000), OLD.[Type], 0)), CONVERT(nvarchar(500), CONVERT(nvarchar(4000), NEW.[Type], 0)))
			
		FROM deleted OLD Inner Join inserted NEW On 
			(CONVERT(nvarchar(4000), NEW.[WareGroupNumber], 0)=CONVERT(nvarchar(4000), OLD.[WareGroupNumber], 0) or (NEW.[WareGroupNumber] Is Null and OLD.[WareGroupNumber] Is Null)) AND (CONVERT(nvarchar(4000), NEW.[FK_Department], 0)=CONVERT(nvarchar(4000), OLD.[FK_Department], 0) or (NEW.[FK_Department] Is Null and OLD.[FK_Department] Is Null)) AND (CONVERT(nvarchar(4000), NEW.[Type], 0)=CONVERT(nvarchar(4000), OLD.[Type], 0) or (NEW.[Type] Is Null and OLD.[Type] Is Null))
			where (
			
			
				(
					NEW.[SortNumber] <>
					OLD.[SortNumber]
				) Or
			
				(
					NEW.[SortNumber] Is Null And
					OLD.[SortNumber] Is Not Null
				) Or
				(
					NEW.[SortNumber] Is Not Null And
					OLD.[SortNumber] Is Null
				)
				)
        
		SET @Inserted = CASE WHEN @@ROWCOUNT > 0 Then 1 Else @Inserted End
	END
	
	-- Watch
	
	-- Lookup
	
	IF @Inserted = 0
	BEGIN
		DELETE FROM dbo.AUDIT_LOG_TRANSACTIONS WHERE AUDIT_LOG_TRANSACTION_ID = @AUDIT_LOG_TRANSACTION_ID
	END
	-- Restore @@IDENTITY Value  
    DECLARE @maxprec AS varchar(2)
    SET @maxprec=CAST(@@MAX_PRECISION as varchar(2))
    EXEC('SELECT IDENTITY(decimal('+@maxprec+',0),'+@IDENTITY_SAVE+',1) id INTO #tmp')
End
